<?php
namespace Planejamento\Exception;

class ExceptionRetiradaGeral extends \Geral\Logic\Exception
{


    private $messageName;
    private $messageNameAcumulado;
    private $paramsAcumulado;


    public function __construct($messagemName, $param = null){
        parent::__construct($messagemName);
        $this->messageName = $messagemName;
        $this->addParam($param);
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }

    /**
     * Retorna o parametro da mensagem para esta excecao.
     *
     * @return string
     */
    public function getParam()
    {
        return is_null(reset($this->getParams())) ? $this->getParams() : reset($this->getParams()); 
    }


    public function acumulaMensagem($NmMensagem, $params){
        $this->messageNameAcumulado = $NmMensagem;
        $this->paramsAcumulado = $params;
    }

    public static function erroMaisDeUmaFilialEscolhida(){
        throw new self('pla01800_qtdFiliais');
    }


    public static function datasDiferentes(){
        throw new self('pla01800_comparaDatas');
    }


    public static function verificaSeEscolheuServico(){
        throw new self('pla01800_verificaSeEscolheuServico');
    }   


    public static function verificaServicoRequisicaoRetirada(){
        throw new self('pla01800_verificaServicoRequisicaoRetirada');
    }


    public static function servicoPossuiRetirada($dtRetirada, $servico){
        $params = array($dtRetirada, $servico);
        throw new self('pla01800_ServicoPossuiRetirada', $params);
    }

    public static function informarQuantidadeConsumida(){
        throw new self('pla08000_informarQuantidadeConsumida');
    }

    public static function naoPossuiRetiradaPadrao(){
        throw new self('pla08000_naoPossuiRetiradaPadrao');
    }


    public static function retiradaAutomatJaRealizada(){
        throw new self('pla01800_retiradaAutomatJaRealizada');
    }
    
}

?>