/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_NUME                                                    */
/* Tabela : NUMERARIO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 25/0642006 - Arnaldo Coutinho Brito Jnior                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_NUME
BEFORE INSERT OR UPDATE OR DELETE
ON NUMERARIO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUNUME := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDNUMERARIO,0) <> NVL(:NEW.CDNUMERARIO,0)) OR
         (NVL(:OLD.NMNUMERARIO,0) <> NVL(:NEW.NMNUMERARIO,0)) OR
         (NVL(:OLD.VRNUMERARIO,0) <> NVL(:NEW.VRNUMERARIO,0)) OR
         (NVL(:OLD.IDNUMERARIO,0) <> NVL(:NEW.IDNUMERARIO,0)) THEN
         :NEW.DTULTATUNUME := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('NUMERARIO', '', 'CDNUMERARIO='||:OLD.CDNUMERARIO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE NUMERARIO MODIFY DTULTATUNUME DEFAULT SYSDATE
/