var Pag16000_EmprestimoLeasing_Service = function(ScreenService, templateManager, General, ZHPromise) {
    this.efetuaCalculoParcelas = function(numeroParcelas, totalEmprestimo, tipoConta, valorAjusteEmp, dataIncrement, sistemaAmortizacao, taxaJuros){
        if (sistemaAmortizacao == 'O'){
            return this.amortizacaoPadrao(numeroParcelas, totalEmprestimo, tipoConta, valorAjusteEmp, dataIncrement);
        }else if (sistemaAmortizacao == 'P'){
            if (taxaJuros == 0){
                return this.amortizacaoPadrao(numeroParcelas, totalEmprestimo, tipoConta, valorAjusteEmp, dataIncrement);
            }else{
                return this.amortizacaoPrice(taxaJuros, numeroParcelas, totalEmprestimo, tipoConta, valorAjusteEmp, dataIncrement);
            }
        }else if (sistemaAmortizacao == 'S'){
            if (taxaJuros == 0){
                return this.amortizacaoPadrao(numeroParcelas, totalEmprestimo, tipoConta, valorAjusteEmp, dataIncrement);
            }else{
                return  this.amortizacaoSac(taxaJuros, numeroParcelas, totalEmprestimo, tipoConta, valorAjusteEmp, dataIncrement);
            }
        }
    };

    this.amortizacaoPadrao = function(numeroParcelas, totalEmprestimo, tipoConta, valorAjusteEmp, dataIncrement){
        var listaParcelas = [];
        var valorAjusteParcela = 0;
        var valorAjusteUltimaParcela = 0;
        if (valorAjusteEmp){
            valorAjusteParcela = parseFloat(valorAjusteEmp / numeroParcelas).toFixed(2);
            valorAjusteUltimaParcela = parseFloat(valorAjusteParcela) + parseFloat((valorAjusteEmp - valorAjusteParcela * numeroParcelas).toFixed(2));
        }
        var parcelasEmprestimo = (totalEmprestimo/numeroParcelas).toFixed(2);
        var parcelasJuros = (parseFloat(parcelasEmprestimo) + parseFloat(valorAjusteParcela)).toFixed(2);
        var restoDivisao  = parseFloat(totalEmprestimo - (parcelasEmprestimo * numeroParcelas)).toFixed(2);
        var ultimaParcela = parseFloat(parcelasEmprestimo) + parseFloat(restoDivisao);
        var ultimaParcelaJuros = ultimaParcela + valorAjusteUltimaParcela;
        var valorDivida   = totalEmprestimo;
        for(var i = 1; i <= numeroParcelas; i++){
            var parcela  = i.toString().padStart(2, "0");
            valorDivida -= parcelasEmprestimo;
            var novaData = (dataIncrement && listaParcelas.length == 0) ? dataIncrement.format('DD/MM/YYYY') : dataIncrement.add(1, 'month').format('DD/MM/YYYY');
            if (i < numeroParcelas){
                listaParcelas.push(
                    {
                        "NRSEQVENPAG"  : parcela,
                        "NRPARCELAPAG" : "00",
                        "DTATUAVENPAG" : novaData,
                        "VRATUAPAG"    : parcelasEmprestimo,
                        "DSCONTAPAG"   : tipoConta + "  " + parcela + "/" + numeroParcelas.toString().padStart(2, "0"),
                        "VRFINALBPAG"  : parcelasJuros,
                        "VRAJUSTE"     : parseFloat(valorAjusteParcela).toFixed(2),
                        "VRDIVIDA"     : valorDivida,
                        "IDSTATPAG"    : 'A'
                    }
                );
            }else{
                listaParcelas.push(
                    {
                        "NRSEQVENPAG"  : parcela,
                        "NRPARCELAPAG" : "00",
                        "DTATUAVENPAG" : novaData,
                        "VRATUAPAG"    : ultimaParcela,
                        "DSCONTAPAG"   : tipoConta + "  " + parcela + "/" + numeroParcelas.toString().padStart(2, "0"),
                        "VRFINALBPAG"  : ultimaParcelaJuros,
                        "VRAJUSTE"     : parseFloat(valorAjusteUltimaParcela).toFixed(2),
                        "VRDIVIDA"     : valorDivida,
                        "IDSTATPAG"    : 'A'
                    }
                );
            }
        }
        return listaParcelas;
    };

    /**
     * [amortizacaoSac description]
     * @param  {[type]} i               [Juros]
     * @param  {[type]} n               [Número de Parcelas]
     * @param  {[type]} totalEmprestimo [description]
     * @param  {[type]} tipoConta       [description]
     * @param  {[type]} valorAjusteEmp  [description]
     * @param  {[type]} dataIncrement   [description]
     * @return {[type]}                 [description]
     */
    this.amortizacaoSac = function(i, n, totalEmprestimo, tipoConta, valorAjusteEmp, dataIncrement){
        n = parseFloat(n);
        var listaParcelas = [];
        var valorAmortizado = (totalEmprestimo/n).toFixed(2);
        var restoDivisao = (totalEmprestimo - (valorAmortizado * n)).toFixed(2);
        var ultimaParcelaAmortizada = parseFloat(valorAmortizado) + parseFloat(restoDivisao);
        var valorBoleto  = 0;
        var saldoDevedor = totalEmprestimo;
        var valorDivida  = totalEmprestimo;
        var valorJuros   = 0;
        for(var j = 1; j <= n; j++){
            valorJuros   = (parseFloat(saldoDevedor) * parseFloat(i) / 100).toFixed(2);
            saldoDevedor = saldoDevedor - valorAmortizado;
            valorDivida -= valorAmortizado;
            var parcela  = j.toString().padStart(2, "0");
            var novaData = (dataIncrement && listaParcelas.length == 0) ? dataIncrement.format('DD/MM/YYYY') : dataIncrement.add(1, 'month').format('DD/MM/YYYY');
            if (j < n){
                valorBoleto = parseFloat(valorAmortizado) + parseFloat(valorJuros);
                listaParcelas.push(
                    {
                        "NRSEQVENPAG"  : parcela,
                        "NRPARCELAPAG" : "00",
                        "DTATUAVENPAG" : novaData,
                        "VRATUAPAG"    : valorAmortizado,
                        "DSCONTAPAG"   : tipoConta + "  " + parcela + "/" + n.toString().padStart(2, "0"),
                        "VRFINALBPAG"  : valorBoleto,
                        "VRAJUSTE"     : valorJuros,
                        "VRDIVIDA"     : valorDivida,
                        "IDSTATPAG"    : 'A'
                    }
                );
            }else{
                valorBoleto = parseFloat(ultimaParcelaAmortizada) + parseFloat(valorJuros);
                listaParcelas.push(
                    {
                        "NRSEQVENPAG"  : parcela,
                        "NRPARCELAPAG" : "00",
                        "DTATUAVENPAG" : novaData,
                        "VRATUAPAG"    : ultimaParcelaAmortizada,
                        "DSCONTAPAG"   : tipoConta + "  " + parcela + "/" + n.toString().padStart(2, "0"),
                        "VRFINALBPAG"  : valorBoleto,
                        "VRAJUSTE"     : valorJuros,
                        "VRDIVIDA"     : valorDivida,
                        "IDSTATPAG"    : 'A'
                    }
                );
            }
        }
        return listaParcelas;
    };

    /**
     * [amortizacaoPrice description]
     * @param  {[type]} i [Taxa de Juros]
     * @param  {[type]} n [Número de períodos]
     * @param  {[type]} valorEmprestimo [Valor do Empréstimo]
     * @return {[type]}           [description]
     */
    this.amortizacaoPrice = function(i, n, totalEmprestimo, tipoConta, valorAjusteEmp, dataIncrement){
        i = parseFloat(i) / 100;
        n = parseFloat(n);
        var listaParcelas = [];
        //Fórmula sistema Price
        var valorBoleto     = ((totalEmprestimo * i)/(1-(1/Math.pow((1+i), n)))).toFixed(2);
        var saldoDevedor    = totalEmprestimo;
        var valorJuros      = 0;
        var valorAmortizado = 0;
        var valorDivida     = totalEmprestimo;
        for(var j = 1; j <= n; j++){
            valorJuros      = (parseFloat(saldoDevedor) * parseFloat(i)).toFixed(2);
            valorAmortizado = valorBoleto - valorJuros;
            valorDivida    -= valorAmortizado;
            saldoDevedor    = saldoDevedor - valorAmortizado;
            var parcela     = j.toString().padStart(2, "0");
            var novaData    = (dataIncrement && listaParcelas.length == 0) ? dataIncrement.format('DD/MM/YYYY') : dataIncrement.add(1, 'month').format('DD/MM/YYYY');
            if (j < n){
                listaParcelas.push(
                    {
                        "NRSEQVENPAG" : parcela,
                        "NRPARCELAPAG": "00",
                        "DTATUAVENPAG": novaData,
                        "VRATUAPAG"   : valorAmortizado,
                        "DSCONTAPAG"  : tipoConta + "  " + parcela + "/" + n.toString().padStart(2, "0"),
                        "VRFINALBPAG" : valorBoleto,
                        "VRAJUSTE"    : valorJuros,
                        "VRDIVIDA"    : valorDivida,
                        "IDSTATPAG"   : 'A'
                    }
                );
            }else{
                listaParcelas.push(
                    {
                        "NRSEQVENPAG" : parcela,
                        "NRPARCELAPAG": "00",
                        "DTATUAVENPAG": novaData,
                        "VRATUAPAG"   : (valorAmortizado + saldoDevedor).toFixed(2),
                        "DSCONTAPAG"  : tipoConta + "  " + parcela + "/" + n.toString().padStart(2, "0"),
                        "VRFINALBPAG" : valorBoleto,
                        "VRAJUSTE"    : (valorJuros - saldoDevedor).toFixed(2),
                        "VRDIVIDA"    : valorDivida,
                        "IDSTATPAG"   : 'A'
                    }
                );
            }
        }
        return listaParcelas;
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('Pag16000_EmprestimoLeasing_Service', Pag16000_EmprestimoLeasing_Service);
});